# Want to redo the numerical simulation in chapter 2.5
from numpy import *
from scipy import *
from math import *
from random import *
import matplotlib.pyplot as plt

M = []

d = 1
while d <= 10:
    row = []
    i = 1
    while i <= 10:
        if i == d:
            row.append(1)
            i += 1
        else:
            row.append(d*i/100.0)
            i += 1
    M.append(row)
    d += 1
    
M = array(M,float)
inv_sigma = dot(M,M)

sigma = linalg.inv(inv_sigma)


def density(x):
    #pass in array x
    b = dot(dot(x,inv_sigma),x)
    c = exp(-0.5*b)
    d = 1/float(((2*pi)**5)*sqrt(linalg.det(sigma))) * c
    return d

def RWM(s, steps):
    #s is sigma the scaling
    reject_times = 0
    X = array([5,0,0,0,0,0,0,0,0,0],float)
    s_square = s**2
    #times = []
    #X_squares = []

    i = 1
    sum = 0
    while i <= steps:
        #first generate random vector from normal distribution.
        Z = []
        j = 1
        while j <= 10:
            Z.append(normalvariate(0,s_square))
            j += 1
        Z = array(Z,float)
        Y_pro = X + Z
        if density(X) == 0:
            accept = 1
        else:
            accept = min(density(Y_pro)/float(density(X)),1)
        k = random()
        if k < accept:
            X = Y_pro
            #times.append(i)
            a = X[0]**2
            #X_squares.append(a)
            sum += a
        else:
            X = X #proposal is rejected
            reject_times += 1
            #times.append(i)
            a = X[0]**2
            #X_squares.append(a)
            sum += a
        i += 1
    return sum/float(steps), 1-reject_times/float(steps)#, times, X_squares
    #last sample, average of the first coordinate square, acceptance rate"
    
def run(times,s,steps):
    accuracy = []
    average = []
    i = 1
    while i <= times:
        b = RWM(s, steps)
        accuracy.append(b[1])
        average.append(b[0])
        i += 1
    return mean(accuracy), mean(average), std(average), average

    
#def get_trace_plots(s,step):
    #x = array(RWM(s, step)[2])
    #y = array(RWM(s, step)[3])
    #plt.plot(x,y, 'g')
    #plt.show()   

#p = RWM(0.55, 1000)
    
#x = array(p[2])
#y = array(p[3])
#plt.plot(x,y, 'b')
#plt.show()     
#print p[1]
        
        
        

    
    



    
            